#
# make rules for the vfs system
#

# option settings

# option implementations

ifdef DEBUG
OPTIONFLAGS:= -DDEB
CFLAGS:= -g
else
OPTIONFLAGS:= -DNDEBUG
CFLAGS:= -O2
endif

# directories
ifeq "${VARIANT}" ""
PDIR:= all
else
PREFIX:= ${VARIANT}
UNDERSCORE:= _
PDIR:= ${PREFIX}
endif

ifdef BUILD_LOCAL
AR_DIR:= .
BIN_DIR:= .
OBJ_DIR:= .
else
AR_DIR:= ${GEN}/c/file/obj
BIN_DIR= ${GEN}/c/file/${PREFIX}_bin
OBJ_DIR= ${AR_DIR}/${PDIR}
endif


#OTHER_DIR:= other
INCLUDE_DIR:= ../include

# Machine dependant stuff

MACH:= ${shell uname}
include ${MACH}.mk
include subsys.mk

# Compiler flags

INCLUDES:= -I/usr/include -I../include -I../util ${SUBSYS_INCLUDE}
CFLAGS+= ${OPTIONFLAGS} ${MACH_CFLAGS} ${BUILD_DEFINES} ${MACH_DEFINES} ${INCLUDES} ${SUBSYS_CFLAGS} -c
COMPILE:= ${CC} ${CFLAGS}
LINK:= ${CC}
LINK_FLAGS:= ${MACH_CFLAGS} -L${AR_DIR} ${MACH_LINKFLGS} ${SUBSYS_LINKFLAGS}
LINK_LIBS:= ${MACH_LINKLIBS} ${SUBSYS_LINKLIBS}

# utility programs

RM:= rm -f
LN:= ln

# command macros

# archive command macro
define AR_COMMAND
ar r $@ $?
ranlib $@
endef

# move the object to the object directory macro
define MV_OBJECT
test -d ${dir $@} || mkdir -p ${dir $@}
mv ${notdir $@} _temp.o
rm -f ${notdir $@} 
mv _temp.o $@
endef

define COMPILE_COMMAND
${COMPILE} $<
${MV_OBJECT}
endef

print3:
	echo PDIR ${PDIR}
